from typing import TYPE_CHECKING, Any, Dict, List, Type, TypeVar, Union

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

if TYPE_CHECKING:
    from ..models.radio_port import RadioPort


T = TypeVar("T", bound="RadioPortList")


@_attrs_define
class RadioPortList:
    """
    Attributes:
        radio_ports (Union[Unset, List['RadioPort']]):
    """

    radio_ports: Union[Unset, List["RadioPort"]] = UNSET
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        radio_ports: Union[Unset, List[Dict[str, Any]]] = UNSET
        if not isinstance(self.radio_ports, Unset):
            radio_ports = []
            for radio_ports_item_data in self.radio_ports:
                radio_ports_item = radio_ports_item_data.to_dict()
                radio_ports.append(radio_ports_item)

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if radio_ports is not UNSET:
            field_dict["radio_ports"] = radio_ports

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        from ..models.radio_port import RadioPort

        d = src_dict.copy()
        radio_ports = []
        _radio_ports = d.pop("radio_ports", UNSET)
        for radio_ports_item_data in _radio_ports or []:
            radio_ports_item = RadioPort.from_dict(radio_ports_item_data)

            radio_ports.append(radio_ports_item)

        radio_port_list = cls(
            radio_ports=radio_ports,
        )

        radio_port_list.additional_properties = d
        return radio_port_list

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
